#%define ffmpegsvn		20061030

%define _unpackaged_files_terminate_build 0
%define with_optimization 	1
%define with_debug 		0
%define with_xinerama 		1
%define with_ogg 		1
%define with_xvid 		1
%define with_ffmpeg 		1
%define with_ffmpeg_amrnb	0
%define with_ffmpeg_amrnb_fixed	0
%define with_ffmpeg_amrwb	0
%define with_lame 		1
%define with_faac 		1
%define with_x264 		1
%define with_dvb 		0
%define with_zvbi 		1
%define with_lirc 		1
%define with_alsa 		1
%define with_png 		1
%define with_jpeg 		1

%define liba52  %{_libdir}/liba52.so.0

#without
%{?_without_optimization: 	%{expand: %%global with_optimization 0}}
%{?_without_debug: 		%{expand: %%global with_debug 0}}
%{?_without_xinerama: 		%{expand: %%global with_xinerama 0}}
%{?_without_ogg: 		%{expand: %%global with_ogg 0}}
%{?_without_xvid: 		%{expand: %%global with_xvid 0}}
%{?_without_ffmpeg: 		%{expand: %%global with_ffmpeg 0}}
%{?_without_ffmpeg_amrnb:	%{expand: %%global with_ffmpeg_amrnb 0}}
%{?_without_ffmpeg_amrnb_fixed:	%{expand: %%global with_ffmpeg_amrnb_fixed 0}}
%{?_without_ffmpeg_amrwb:	%{expand: %%global with_ffmpeg_amrwb 0}}
%{?_without_lame: 		%{expand: %%global with_lame 0}}
%{?_without_faac: 		%{expand: %%global with_faac 0}}
%{?_without_x264: 		%{expand: %%global with_x264 0}}
%{?_without_dvb: 		%{expand: %%global with_dvb 0}}
%{?_without_zvbi: 		%{expand: %%global with_zvbi 0}}
%{?_without_lirc: 		%{expand: %%global with_lirc 0}}
%{?_without_alsa: 		%{expand: %%global with_alsa 0}}
%{?_without_png: 		%{expand: %%global with_png 0}}
%{?_without_jpeg: 		%{expand: %%global with_jpeg 0}}

#with
%{?_with_optimization: 		%{expand: %%global with_optimization 1}}
%{?_with_debug: 		%{expand: %%global with_debug 1}}
%{?_with_xinerama: 		%{expand: %%global with_xinerama 1}}
%{?_with_ogg: 			%{expand: %%global with_ogg 1}}
%{?_with_xvid: 			%{expand: %%global with_xvid 1}}
%{?_with_ffmpeg: 		%{expand: %%global with_ffmpeg 1}}
%{?_with_ffmpeg_amrnb: 		%{expand: %%global with_ffmpeg_amrnb 1}}
%{?_with_ffmpeg_amrnb_fixed: 	%{expand: %%global with_ffmpeg_amrnb_fixed 1}}
%{?_with_ffmpeg_amrwb: 		%{expand: %%global with_ffmpeg_amrwb 1}}
%{?_with_lame: 			%{expand: %%global with_lame 1}}
%{?_with_faac: 			%{expand: %%global with_faac 1}}
%{?_with_x264: 			%{expand: %%global with_x264 1}}
%{?_with_dvb: 			%{expand: %%global with_dvb 1}}
%{?_with_zvbi: 			%{expand: %%global with_zvbi 1}}
%{?_with_lirc: 			%{expand: %%global with_lirc 1}}
%{?_with_alsa: 			%{expand: %%global with_alsa 1}}
%{?_with_png: 			%{expand: %%global with_png 1}}
%{?_with_jpeg: 			%{expand: %%global with_jpeg 1}}

Name:           xdtv
Version:        2.4.0
Release:        1%{?dist}
Summary:        Video4Linux Stream Capture Viewer & Recorder

Group:          Applications/Multimedia
License:        GPL
URL:            http://xawdecode.sourceforge.net/
Source0:        http://kent.dl.sourceforge.net/sourceforge/xawdecode/xdtv-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


BuildRequires:  texi2html
BuildRequires:  faad2-devel
BuildRequires:  imlib2-devel

BuildRequires:	ffmpeg-devel
BuildRequires:  libX11-devel
BuildRequires:  libXext-devel
BuildRequires:  libXmu-devel
BuildRequires:  libXt-devel
BuildRequires:  libXv-devel
BuildRequires:  libXxf86dga-devel
BuildRequires:  libXxf86vm-devel
BuildRequires:  libXpm-devel
BuildRequires:  libXaw-devel
BuildRequires:  xorg-x11-server-utils
BuildRequires:  xorg-x11-font-utils
BuildRequires:  desktop-file-utils
%if %with_xinerama
BuildRequires:  libXinerama-devel
%endif
%if %with_xvid
BuildRequires:  xvidcore-devel
%endif
%if %with_faac
BuildRequires:  faac-devel
%endif
%if %with_x264
BuildRequires:  x264-devel
%endif
%if %with_lame
BuildRequires:  lame-devel
%endif
%if %with_zvbi
BuildRequires:  zvbi-devel
%endif
%if %with_lirc
BuildRequires:  lirc-devel
%endif
%if %with_jpeg
BuildRequires:  libjpeg-devel
%endif
%if %with_png
BuildRequires:  libpng-devel
%endif
%if %with_ogg
BuildRequires:  libtheora-devel >= 1.0alpha5
BuildRequires:  libvorbis-devel >= 1.1.0
BuildRequires:  libogg-devel >= 1.1.2
%endif
%if %with_alsa
BuildRequires:  alsa-lib-devel
%endif
BuildRequires:  neXtaw-devel
BuildRequires:  gcc-c++
%if %with_dvb
BuildRequires:  SDL-devel
BuildRequires:  curl-devel
%endif


%description
XdTV is a software that allows you to to record & watch TV.
It interacts with AleVT for Teletext and Nxtvepg for NextView,
and uses the video4linux API. It can use some deinterlacing filters
and can record video files in various containers (AVI, MPEG, OGG, etc.) 
with many codecs (FFMpeg(>=0.4.6), XviD(0.9 & 1.x),
Ogg Theora (>=1.0alpha5) & Vorbis and DivX4/5).
It has also some plugin capabilities.

%package        devel
Summary:        Developpement files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
Developpement files for %{name}

%package        OSD-font
Summary:        Font used by %{name} OSD function
Group:          User Interface/X
Requires:       %{name} = %{version}-%{release}

%description    OSD-font
Font used by %{name} OSD function.

# -----------------------------------------------------------------------------

%prep
%setup -q -n %{name}-%{version}

#kwizart try to tweak src for xdtv
sed -i -e 's|"lame/lame.h"|<lame/lame.h>|' src/divx.c
sed -i -e 's|"avcodec.h"|<ffmpeg/avcodec.h>|' src/divx.h
sed -i -e 's|"avformat.h"|<ffmpeg/avformat.h>|' src/divx.h

# fix flags
#sed -i -e 's|PERF_FLAGS = -O4  -fstrength-reduce -frerun-loop-opt -fexpensive-optimizations -fschedule-insns2 -funroll-loops -fomit-frame-pointer -fno-strict-aliasing -pipe  -ffast-math|PERF_FLAGS =$(CFLAGS)|' src/Makefile
sed -i -e 's|PERF_FLAGS =|PERF_FLAGS =$(CFLAGS) \nPERF_FLAGS =|' src/Makefile.am


# -----------------------------------------------------------------------------

%build
%configure --prefix=%{_prefix} --mandir=%{_mandir} --libdir=%{_libdir} --disable-divx4linux --with-fontdir=%{_prefix}/share/X11/fonts/misc --with-x --enable-xvideo --with-external-ffmpeg \
%if %with_optimization 
	--enable-cpu-detection \
%else
	--disable-cpu-detection \
%endif
%if %with_debug
	--disable-nodebug \
%else
	--enable-nodebug \
%endif
%if %with_xinerama
	--enable-xinerama \
%else
	--disable-xinerama \
%endif
%if %with_ogg
	--enable-ogg \
%else
	--disable-ogg \
%endif
%if %with_xvid
	--enable-xvid \
%else
	--disable-xvid \
%endif
%if %with_ffmpeg
	--enable-ffmpeg \
%else
	--disable-ffmpeg \
%endif
%if %with_ffmpeg_amrnb
	--enable-ffmpeg-amrnb \
%else
	--disable-ffmpeg-amrnb \
%endif
%if %with_ffmpeg_amrnb_fixed
	--enable-ffmpeg-amrnb-fixed \
%else
	--disable-ffmpeg-amrnb-fixed \
%endif
%if %with_ffmpeg_amrwb
	--enable-ffmpeg-amrwb \
%else
	--disable-ffmpeg-amrwb \
%endif
%if %with_lame
	--enable-lame \
%else
	--disable-lame \
%endif
%if %with_faac
	--enable-faac \
%else
	--disable-faac \
%endif
%if %with_x264
	--enable-x264 \
%else
	--disable-x264 \
%endif
%if %with_zvbi
	--enable-zvbi \
%else
	--disable-zvbi \
%endif
%if %with_lirc
	--enable-lirc \
%else
	--disable-lirc \
%endif
%if %with_dvb
	--enable-dvb \
%else
	--disable-dvb \
%endif
%if %with_alsa
	--enable-alsa \
%else
	--disable-alsa \
%endif
%if %with_jpeg
	--enable-jpeg \
%else
	--disable-jpeg \
%endif
%if %with_png
	--enable-png \
%else
	--disable-png \
%endif



make prefix=%{_prefix}

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}
make prefix=%{_prefix} DESTDIR="$RPM_BUILD_ROOT" install
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_v4l-conf
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_wizard
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_cmd
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_scantv
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_alevt*

#mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
#install -m 644 man/xdtv.1 $RPM_BUILD_ROOT%{_mandir}/man1/xdtv.1
#install -m 644 man/xdtv_cmd.1 $RPM_BUILD_ROOT%{_mandir}/man1/xdtv_cmd.1
#install -m 644 man/xdtv_alevt.1 $RPM_BUILD_ROOT%{_mandir}/man1/xdtv_alevt.1
#install -m 644 man/xdtv_alevt-cap.1 $RPM_BUILD_ROOT%{_mandir}/man1/xdtv_alevt-cap.1
bzip2 $RPM_BUILD_ROOT%{_mandir}/man1/*.1
#rm -rf $RPM_BUILD_ROOT/usr/man/man1/
rm -rf $RPM_BUILD_ROOT%{_datadir}/X11/fonts/misc/fonts.dir
rm -rf $RPM_BUILD_ROOT%{_datadir}/X11/fonts/misc/fonts.scale

mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
#install -m 644 xdtv-48.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/xdtv.png
#install -m 644 xdtv.desktop $RPM_BUILD_ROOT%{_datadir}/applications/xdtv.desktop
#install -m 644 xdtv_wizard.desktop $RPM_BUILD_ROOT%{_datadir}/applications/xdtv_wizard.desktop
ln -fs ../xdtv/icons/xdtv-48.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/xdtv.png

%{__cat} <<EOF >xdtv.desktop
[Desktop Entry]
Name=XdTV
Comment=Video4Linux Stream Capture Viewer & Recorder
Exec=xdtv
Icon=xdtv.png
Terminal=false
Type=Application
Categories=AudioVideo;Application;
EOF

desktop-file-install --delete-original \
--vendor "" \
--dir $RPM_BUILD_ROOT%{_datadir}/applications \
--mode 0644 \
xdtv.desktop

%{__cat} <<EOF >xdtv_wizard.desktop
[Desktop Entry]
Name=XdTV Wizard
Comment=XdTV Wizard
Exec=xdtv_wizard
Icon=xdtv.png
Terminal=false
Type=Application
Categories=AudioVideo;Application;
EOF

desktop-file-install --delete-original \
--vendor "" \
--dir $RPM_BUILD_ROOT%{_datadir}/applications \
--mode 0644 \
xdtv_wizard.desktop

rm -f $RPM_BUILD_ROOT%{_infodir}/dir
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} ';'

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%post
/sbin/ldconfig
/usr/bin/update-desktop-database -q
/sbin/install-info %{_infodir}/%{name}.info %{_infodir}/dir 2>/dev/null || :

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete %{_infodir}/%{name}.info %{_infodir}/dir 2>/dev/null || :
fi

%postun
/sbin/ldconfig
/usr/bin/update-desktop-database -q

%post OSD-font
if [ -x %{_bindir}/fc-cache ]; then
   %{_bindir}/fc-cache %{_datadir}/fonts
fi

%postun OSD-font
if [ "$1" = "0" ]; then
   if [ -x %{_bindir}/fc-cache ]; then
      %{_bindir}/fc-cache %{_datadir}/fonts
   fi
fi

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING INSTALL FAQfr-xdtv TODO
%doc README README.dvb README.record README.bs README.ffmpeg README.streaming
%doc README.bsd README.gentoo README.xvid README.buildme README.lirc
%doc README.deinterlace README.plugins ChangeLog lisez-moi xdtvrc.sample
%doc lircrc.miro.sample lircrc.hauppauge.sample lircrc.animax.sample
%doc lircrc.WinfastTV2000.sample
%{_bindir}/*
%{_datadir}/X11/app-defaults/XdTV
%config %{_sysconfdir}/xdtv/%{name}_wizard-en.conf
%config %{_sysconfdir}/xdtv/%{name}_wizard-en-UTF8.conf
%{_datadir}/pixmaps/*.png
%{_datadir}/xdtv/icons/*
%{_datadir}/applications/*xdtv.desktop
%{_datadir}/applications/*xdtv_wizard.desktop
%{_mandir}/man1/*.1.gz

%files devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/*

%files OSD-font
%defattr(-,root,root,-)
%{_datadir}/X11/fonts/misc/*.pcf.gz


%changelog
* Mon Feb 27 2007 kwizart < kwizart at gmail.com > - 2.4.0-1
- Update to final 2.4.0
- remove desktop file vendor and add category

* Mon Feb 05 2007 kwizart < kwizart at gmail.com > - 2.4.0-0.10.pre0
- Fix compile flags

* Wed Jan  3 2007 kwizart < kwizart at gmail.com > - 2.4.0-0.9.pre0
- ffmpeg-rebuild
- some patches from gentoo
- conform to versioning guidelines
- tweak some includes in divx.h
- Enabled Optimization

* Sun Dec 17 2006 kwizart < kwizart at gmail.com > 2.4.0pre0-8.kwizart.fc6
- Try to use ffmpeg-amr-devel with static lib with xdtv

* Sun Dec 10 2006 kwizart < kwizart at gmail.com > 0:2.4.0pre0-7.kwizart.fc6
- Cleaned spec file.

* Sat Nov 11 2006 kwizart < kwizart at gmail.com > 0:2.4.0pre0-6.kwizart.fc6
- libdir in configure.
- cleaned spec file for livna.org.
- Now use updated ffmpeg tarball from livna 20061030 src.rpm.
- Re-use x264 from livna.

* Wed Nov 06 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-5.kwizart.fc6
- New release for fc6

* Tue Oct 17 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-4.kwizart.FC5
- dropped x264 - recent x264 version won't build with xdtv
- man files are in correct place.

* Sat Sep 22 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-3.kwizart.FC5
- amr support (amrnb_float amrwb_float).

* Sun Sep 16 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-2.kwizart.FC5
- Cleaned $RPM_BUILD_ROOT tags / 
- Problem with application cache / fixed?

* Fri Aug 04 2006 kwizart < kwizart at gmail.com >
- switch to livna release

* Sat Mar 25 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.2-1fc5
- 2.3.2 on FC5
- The system app-defaults/ directory for X resources is now /usr/share/X11/app-defaults/ 
  on Fedora Core 5 and for future Red Hat Enterprise Linux systems.
- FC5 has modular X. All the libraries that were in xorg-x11-devel now have their own packages 
  and you need to include the -devel packages for the libraries your project is actually using.
- all infos here: http://fedora.redhat.com/docs/release-notes/fc5/
- new paths for desktop icons & TV misc fonts & font utils

* Sun Mar 19 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.2-1fc4
- 2.3.2
- fix error with the instalation of the TV fonts (need chkfontpath).
- fix error with the path of the ressource file (not the same path than in a Mandriva distro).
- fix error with the menu update (the menu was not updated).
- fix error with the path of the man files (return back to the old method).

* Fri Feb 24 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.1-1fc4
- 2.3.1
- FFmpeg inside XdTV
- Add the possibility to compile with amr_nb & amr_wb

* Fri Dec 23 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.3.0-1
- 2.3.0
- Compiled with --disable-divx4linux & neXtaw
- Spec file updated

* Sun Jul 03 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.2.0-2
- add the xdtv_wizard menu entry

* Fri Jul 01 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.2.0-1
- Upgrade to 2.2.0
- Compiled with --disable-divx4linux
- Spec file cleanup 

* Sun Apr 03 2005 Emmanuel Seyman <seyman@wanadoo.fr> - 2.1.1-1
- Upgrade to 2.1.1

* Sun Jan 02 2005 Emmanuel Seyman <seyman@wanadoo.fr> - 2.0.1-1
- Upgrade to 2.0.1
- Obsolete xawdecode
- Clean up installation instructions

* Fri Nov 28 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.2-1
- Upgrade to 1.8.2

* Sat Oct 04 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.1-1
- Upgrade to 1.8.1

* Tue Sep 02 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.0-1
- Initial RPM release.
